/*******************************************************************************
 *  The OSD class exists to render the on-screen display; it holds an index
 *  into a texture array (gTextures) rather than holding a texture itself.
 ******************************************************************************/
#ifndef CLASS_OSD_H
#define CLASS_OSD_H

/*
 *  OSD class
 */
class OSD
{
    public:
        /*  Constructor */
        OSD( void );

        /*  Update the OSD */
        void update( const char *string = NULL );

        /*  Set texture index */
        void set_texture_index( int textureIndex );

        /*  Set / get  position */
        void set_position( int x, int y );
        int get_pos_x( void );
        int get_pos_y( void );

        /*  Render to screen */
        void render( void );

    private:
        /*  The text for the OSD */
        char mText[ 64 ];

        /*  Current texture index */
        int mTextureIndex;

        /*  Current position */
        SDL_Point mPos;
};

#endif
