/*******************************************************************************
 *  Paddle class.  Exists to control the AI or to be controlled by the player.
 ******************************************************************************/
#ifndef CLASS_PADDLE_H
#define CLASS_PADDLE_H

/*
 * The paddle class
 */
class Paddle : public RectThing
{
    public:
        /*  Move the paddle */
        void move( void );
        void move_player_keyboard( void );
        void move_player_mouse( SDL_Event &e );
        void move_player_joystick( int padValue );
        void move_ai( void );

        /*  Handle player events */
        void handle_event( SDL_Event &e );

        /*  Set/get AI status */
        void set_ai( bool status );
        bool is_ai( void );

        /*  Set/get player */
        void set_player( int playerNum );
        int get_player( void );

        /*  Set target Y value */
        void set_target_y( int target );

        /*  Set / get difficulty of AI paddle */
        void set_difficulty( int difficulty );
        int get_difficulty( void );

    private:
        /*  Whether or not the paddle is controlled by AI */
        bool isAI;

        /*  Which paddle this is */
        int player;

        /*  Vertical direction of the paddle */
        int dy;
};

#endif
