/*******************************************************************************
 *  This is the parent class for the Paddle and Ball classes.  It contains a
 *  bunch of a stuff that both need -- dimensions, position, colliders,
 *  velocity, etcetera.
 ******************************************************************************/
#ifndef CLASS_RECTTHING_H
#define CLASS_RECTTHING_H


/*
 * The RectThing class, from which the Paddle and Ball classes will be derived
 */
class RectThing
{
    public:
        /*  Constructor */
        RectThing( void );

        /*  Destructor */
        ~RectThing( void );

        /*  Position stuff */
        void set_position( int x, int y );
        int get_pos_x( void );
        int get_pos_y( void );

        /*  Dimension stuff */
        void set_width( int width );
        int get_width( void );
        void set_height( int height );
        int get_height( void );

        /*  Render the thing */
        void render( void );

        /*  Draw the outline */
        void draw_outline( void );

        /*  Return the collider */
        SDL_Rect get_collider( void );

        /*  Init the collider */
        void init_collider( void );

        /*  Set velocity */
        void set_velocity( int xVel, int yVel );
        void set_max_velocity( int velocity );

        /*  Get the velocity */
        void get_velocity( int *vX, int *vY );
        int get_velocity_x( void );
        int get_velocity_y( void );

        /*  Difficulty settings */
        void increase_difficulty( void );
        void decrease_difficulty( void );
        void set_difficulty( int difficulty );
        int get_difficult( void );


    protected:
        /*  Position */
        SDL_Point mPos;

        /*  Dimensions */
        int mWidth;
        int mHeight;

        /*  Velocity */
        int mVelX;
        int mVelY;
        int mMaxVelocity;
        bool mVelocityBleeding;

        /*  Collider */
        SDL_Rect mCollider;

        /*  Number of ticks since last movement */
        int moveTicks;

        /*  AI difficulty of paddle */
        int mDifficulty;
        int mMaxDifficulty;
};

#endif
