/*******************************************************************************
 *  Score class:  Contains an index into gTextures, the score, a render method
 *  and basic positional/dimensional vitals and accessor functions.
 ******************************************************************************/
#ifndef CLASS_SCORE_H
#define CLASS_SCORE_H

/*
 *  The score class
 */
class Score
{
    public:
        /*  Constructor */
        Score( void );

        /*  Destructor */
        ~Score( void );

        /*  Set score */
        void set_score( int s );

        /*  Get the score */
        int get_score( void );

        /*  Set the texture index */
        void set_texture_index( int index );

        /*  Set position */
        void set_position( int x, int y );

        /*  Get the dimensions */
        int get_width( void );
        int get_height( void );

        /*  Render */
        void render( void );

        /*  Set which paddle the score is for */
        void set_paddle( int paddle );

        /*  Set / get max score */
        void set_max_score( int score );
        int get_max_score( void );

    private:
        /*  The score */
        int mScore;

        /*  Max score */
        int mMaxScore;

        /*  Which paddle this score represents */
        int mPaddle;

        /*  Texture index */
        int mTextureIndex;

        /*  Position */
        SDL_Point mPos;
};

#endif
